﻿<AML>
 <Item type="Method" id="F16199C1E000446881FB9D445355A9A2" action="add">
  <comments>2018-02-01--MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			currency_check
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	If Last month rate of SGD currency doesn't have,show Prompt to enter SGD last month rate.Because of SGD need for all transaction.
    If last month rate of currency which is getting from selected sale order Item doesn't have,show Prompt to enter for that currency.
	
Hooks:
	Type:	Form	:	pop_purchase_invoice
	Event:	pop_currency ( onChange )
	
	Type:	ItemType	:	acc_journal_details
	Event:	acc_accountid ( OnEditFinish )
	
	Type:	Form	:	Acc_AccountPayable
	Event:	acc_cash_account ( onChange )
	
	Type:	Form	:	acc_income_expense_header
	Event:	acc_cash_account ( onChange )
	
	Type:	Form	:	acc_AccountsReceivable
	Event:	acc_currency ( onChange )
	
	Type:	Form	:	acc_income_expense_header
	Event:	acc_currency ( onBlur )
	
	Type:	Form	:	sop_sale_order
	Event:	pop_currency ( onChange )
	
	Type:	Form	:	sop_po_out
	Event:	pop_currency ( onChange )
	
	Type:	Form	:	sop_sale_invoice
	Event:	pop_currency ( onChange )
	
	Type:	Form	:	sop_commercial_invoice
	Event:	pop_currency ( onChange )
	
	Type:	Form	:	sop_po_out
	Event:	pop_vendor ( onChange )

Revisions:
	Rev Date		Modified By			Description
	2018-02-01		MyoThet			Edit prompt message for Rate conversion
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();
var parent_id = top.aras.getItemProperty(document.item, 'id');
var itemType = parent.thisItem.getType().toString().toLowerCase();

switch (itemType) {
    case 'pop_purchase_invoice':
        {
            var invoice_date = top.aras.getItemProperty(document.item, 'pop_invoice_date');
        }
        break;

    case 'sop_sale_order':
        {
            var invoice_date = top.aras.getItemProperty(document.item, 'sop_order_date');
        }
        break;

    case 'sop_po_out':
        {
            var invoice_date = top.aras.getItemProperty(document.item, 'pop_po_date');
        }
        break;

    case 'sop_sale_invoice':
    case 'sop_commercial_invoice':
        {
            var invoice_date = top.aras.getItemProperty(document.item, 'sop_invoice_date');
        }
        break;

    case 'acc_accountsreceivable':
    case 'acc_accountpayable':
        {
            var invoice_date = top.aras.getItemProperty(document.item, 'acc_date');
        }
        break;

    case 'acc_income_expense_header':
        {
            var invoice_date = top.aras.getItemProperty(document.item, 'acc_payment_date');
        }
        break;

    case 'acc_journal_header':
        {
            var invoice_date = parent.thisItem.getProperty('acc_date');
        }
        break;

}

if (itemType == 'acc_journal_header') {
    var checkcurrency = myInnovator.newItem("acc_currency", "get");
} else {
    var checkcurrency = document.thisItem.newItem("acc_currency", "get");
}

var SGD_id = "374D7C8DC875411A9A3BD0FC5A8BC066";
checkcurrency.setProperty("id", SGD_id);
checkcurrency.setPropertyCondition("id", "eq");
var SGD_checkcurrency = checkcurrency.apply();
var SGD_code = SGD_checkcurrency.getProperty("acc_currencycode", "");

var SGD_return_message = top.aras.applyMethod("acc_check_currency_detail", "<id>" + SGD_id + "</id>" +
    "<invoice_date>" + invoice_date + "</invoice_date>");

if (SGD_return_message === "<Result/>") {

    var myName;
    do {
        myName = prompt("This Form need " + SGD_code + " Rate conversion. Please provide last month Rate.", ""); //2018-02-01--MyoThet
    } while (myName === "" || myName === null)
    top.aras.applyMethod("acc_lastmonth_lastday", "<invoice_date>" + invoice_date + "</invoice_date>" + "<myName>" + myName + "</myName>" + "<id>" + SGD_id + "</id>");
}


var currency_id = "";
switch (itemType) {
    case 'sop_sale_invoice':
    case 'pop_purchase_invoice':
    case 'sop_commercial_invoice':
    case 'sop_sale_order':
    case 'sop_po_out':
        {
            currency_id = document.thisItem.getProperty("pop_currency", "");
        }
        break;

    case 'acc_accountsreceivable':
        {
            currency_id = document.thisItem.getProperty("acc_currency", "");

        }
        break;

    case 'acc_income_expense_header':
    case 'acc_accountpayable':

        {
            var acc_cash_account_id = document.thisItem.getProperty("acc_cash_account", "");
            var acc_details = myInnovator.newItem("acc_AccountDetails", "get");
            acc_details.setProperty("id", acc_cash_account_id);
            acc_details.setPropertyCondition("id", "eq");
            var acc_details = acc_details.apply();
            var count = acc_details.getItemCount();
            currency_id = acc_details.getProperty("acc_currency", "");
        }
        break;

    case 'acc_journal_header':
        {
            var relitm = parent.thisItem.getItemsByXPath("//Item[@id='" + relationshipID + "']");
            var currency_id = relitm.getProperty("acc_currency");
        }
        break;
}

checkcurrency.setProperty("id", currency_id);
checkcurrency.setPropertyCondition("id", "eq");
checkcurrency = checkcurrency.apply();
var l_acc_count = checkcurrency.getItemCount();
if (l_acc_count > 0) {

    var acc_currencycode = checkcurrency.getProperty("acc_currencycode", "");

    if (acc_currencycode != "USD") {

        var return_message = top.aras.applyMethod("acc_check_currency_detail", "<id>" + currency_id + "</id>" +
            "<invoice_date>" + invoice_date + "</invoice_date>");

        if (return_message === "<Result/>") {

            var myName;
            do {
                myName = prompt(acc_currencycode + " Rate", "")
            } while (myName === "" || myName === null)
            top.aras.applyMethod("acc_lastmonth_lastday", "<invoice_date>" + invoice_date + "</invoice_date>" + "<myName>" + myName + "</myName>" + "<id>" + currency_id + "</id>");

        }
    }
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>currency_check</name>
 </Item>
</AML>